﻿using System;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Threading;
using System.Diagnostics;
using Microsoft.Win32;
using Low_Specs_Experience_X.Properties;
using System.Net.Http;
using System.Text.RegularExpressions;
using System.Runtime.InteropServices;
using System.Reflection;
using System.Reflection.Emit;
using System.Management;

namespace Low_Specs_Experience_X
{
    public partial class mainUI : Form
    {
        string windowName = "Low Specs Experience";

        string buttonName_Home = "              Home";
        string buttonName_OptimizationCatalog = "              Optimization Catalog";
        string buttonName_CheckForUpdates = "              Check for Updates";
        string buttonName_ContactSupport = "              Contact Support";
        string buttonName_GettingStarted = "              Quick Start Guide";
        string buttonName_AppSettings = "              App Settings";

        string messageExternalLinkRedirectQuestion = "Low Specs Experience will now open and redirect you to an external link opening in your default web browser. Do you wish to proceed?";
        string captionExternalLinkRedirectQuestion = "External Link Redirect";

        string messageExternalLinkRedirectError = "An internal error has occurred while trying to process your request. Please restart the Low Specs Experience and try again or contact support for assistance via email at support@ragnotechpowered.com.";
        string captionExternalLinkRedirectError = "Internal Error 201";

        string messageCheckForUpdatesQuestionError = "An internal error has occurred while trying to process your request. Please ensure that you're connected to the Internet, restart the Low Specs Experience and try again or contact support for assistance.";
        string captionCheckForUpdatesQuestionError = "Internal Error 202";

        string messageCheckForUpdatesQuestion = "Low Specs Experience will now check if a newer version is available. Do you wish to proceed?";
        string captionCheckForUpdatesQuestion = "Check for Updates";

        string messageCheckForUpdatesQuestionPermission = "Low Specs Experience requires admin rights to performn this action. Please close the Low Specs Experience and run it as admin.";
        string captionCheckForUpdatesQuestionPermission = "Admin Rights Required";

        string dateStringExpires;

        DateTime trialDateExpiration;

        private const string InstallationDateKey = "InstallationDate";
        private const int TrialPeriodDays = 14;
        private readonly string[] folderPathsVeto;
        private readonly string[] folderPaths;

        private string dateDisplayFinal = "--:--:--";

        static string strtpcntr = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Temp Cached Modifiable Data v4779");
        static string strtpcntrAlt = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), "Temporary 88791230 Dataset");

        static string nstldtstr = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Deenant Development Labs");
        static string nstldtstrAlt = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), "CSF06 Data Solutions");

        private string strtpcntrA;
        private string strtpcntrAltA;
        private string nstldtstrA;
        private string nstldtstrAltA;
        private string trCheckerManipA;

        private string fileContent;

        string configFilePath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Keegan AB", "current_user", "startup_key_A.cfg");
        string configFilePathAlt = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Keegan AB", "current_user", "startup_key_B.cfg");
        string ksFilePath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Keegan AB", "current_user", "startup_key_ks.cfg");
        string configFilePathManipPath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Manip Solutions");
        string configFilePathManipPathF = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Manip Solutions", "f11623dfcb294645b8cf739686a5fa6f.txt");
        
        string startupCounterPathSearch = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Neon Softworks LLC", "build_2024_11");
        string startupCounterOnLoadPathSearch = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "SEP Log");
        string startupCounterTEMPPathSearch = Path.GetTempPath();
        string startupCounterAppConfigPathSearch = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Ragnotechpowered");

        string startupCounterPathSearchFile;
        string startupCounterOnLoadPathSearchFile;
        string startupCounterTEMPPathSearchFile;
        string startupCounterAppConfigPathSearchFile;

        readonly string trCheckerManip = Environment.GetFolderPath(Environment.SpecialFolder.UserProfile) + @"\AppData\Local\Manip SSolutions\f11623dfcb294645b8cf439686a5fa6f.txt";
        readonly string trChecker = Environment.GetFolderPath(Environment.SpecialFolder.UserProfile) + @"\AppData\Local\MSVStudio_Temp\97db578f7ee94953aab2c52f7af76951.txt";
        readonly string trCheckerAlt = Environment.GetFolderPath(Environment.SpecialFolder.UserProfile) + @"\AppData\Local\trCheckerWsW\467e37d5fbac4ea48528d271d2b5e349.txt";
        readonly string trCherckerAltt = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location) + @"\Tools\21772c5d001a4ed5b03882c702aa4651.txt";

        readonly string trCheckerManip0 = Environment.GetFolderPath(Environment.SpecialFolder.UserProfile) + @"\AppData\Local\Manip SSolutions\";
        readonly string trChecker0 = Environment.GetFolderPath(Environment.SpecialFolder.UserProfile) + @"\AppData\Local\MSVStudio_Temp\";
        readonly string trCheckerAlt0 = Environment.GetFolderPath(Environment.SpecialFolder.UserProfile) + @"\AppData\Local\trCheckerWsW\";
        readonly string trCherckerAltt0 = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location) + @"\Tools\";

        private DateTime installationDate;
        private DateTime expirationDate;
        private DateTime currentDate;

        bool trActWasRun;

        long currentOnlineTime;

        private bool trialTamperProtectionA;
        private bool trialTamperProtectionB;
        private bool trialTamperProtectionFinal;

        string file;

        int component;

        string errReport;

        // string randomGuid = Guid.NewGuid().ToString().Replace("-", "");

        public mainUI()
        {
            InitializeComponent();

            LanguageChanger();

            SetUserInterfaceColor();

            this.Text = windowName;

            // Button names
            HomeButton.Text = buttonName_Home;
            OptimizationCatalogButton.Text = buttonName_OptimizationCatalog;
            checkForUpdatesButton.Text = buttonName_CheckForUpdates;
            SupportAndHelpButton.Text = buttonName_ContactSupport;
            GettingStartedButton.Text = buttonName_GettingStarted;
            SettingsButton.Text = buttonName_AppSettings;

            folderPathsVeto = new string[] { strtpcntr, strtpcntrAlt };
            folderPaths = new string[] { nstldtstr, nstldtstrAlt };

            // Initialize file paths
            strtpcntrA = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Temp Cached Modifiable Data v4779", "active.txt");
            strtpcntrAltA = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), "Temporary 88791230 Dataset", "active.txt");
            nstldtstrA = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Deenant Development Labs", "debug.txt");
            nstldtstrAltA = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), "CSF06 Data Solutions", "debug.txt");
            trCheckerManipA = configFilePathManipPathF;

            premiumActivate.MouseEnter += premiumActivateMouseEnter;
            premiumActivate.MouseLeave += premiumActivateMouseLeave;
            // premiumActivate.MouseClick += premiumActivateMouseClick;

            premiumGet.MouseEnter += premiumGetMouseEnter;
            premiumGet.MouseLeave += premiumGetMouseLeave;
            // premiumGet.MouseClick += premiumGetMouseClick;

            // Main UI buttons
            HomeButton.MouseEnter += HomeButtonMouseEnter;
            HomeButton.MouseLeave += HomeButtonMouseLeave;
            HomeButton.MouseClick += HomeButtonMouseClick;

            OptimizationCatalogButton.MouseEnter += OptimizationCatalogButtonMouseEnter;
            OptimizationCatalogButton.MouseLeave += OptimizationCatalogButtonMouseLeave;
            OptimizationCatalogButton.MouseClick += OptimizationCatalogButtonMouseClick;

            SupportAndHelpButton.MouseEnter += SupportButtonMouseEnter;
            SupportAndHelpButton.MouseLeave += SupportButtonMouseLeave;
            // SupportAndHelpButton.MouseClick += SupportButtonMouseClick;

            SettingsButton.MouseEnter += SettingsButtonMouseEnter;
            SettingsButton.MouseLeave += SettingsButtonMouseLeave;
            SettingsButton.MouseClick += SettingsButtonMouseClick;

            GettingStartedButton.MouseEnter += GettingStartedButtonMouseEnter;
            GettingStartedButton.MouseLeave += GettingStartedButtonMouseLeave;
            // GettingStartedButton.MouseClick += GettingStartedMouseClick;

            checkForUpdatesButton.MouseEnter += checkForUpdatesButtonMouseEnter;
            checkForUpdatesButton.MouseLeave += checkForUpdatesButtonMouseLeave;
            // checkForUpdatesButton.MouseClick += checkForUpdatesButtonMouseClick;

            // Social links
            socialsFacebook.MouseEnter += socialsFacebookMouseEnter;
            socialsFacebook.MouseLeave += socialsFacebookMouseLeave;

            socialsTwitter.MouseEnter += socialsTwitterMouseEnter;
            socialsTwitter.MouseLeave += socialsTwitterMouseLeave;

            socialsYouTube.MouseEnter += socialsYouTubeMouseEnter;
            socialsYouTube.MouseLeave += socialsYouTubeMouseLeave;

            HomeButton.Image = Properties.Resources.HomeButtonWhite;
            HomeButton.ForeColor = Color.White;

            OptimizationCatalogButton.Image = Properties.Resources.OptimizeButtonGray;
            OptimizationCatalogButton.ForeColor = Color.DarkGray;

            SupportAndHelpButton.Image = Properties.Resources.SupportButtonGray;
            SupportAndHelpButton.ForeColor = Color.DarkGray;

            GettingStartedButton.Image = Properties.Resources.GettingStartedGray;
            GettingStartedButton.ForeColor = Color.DarkGray;

            SettingsButton.Image = Properties.Resources.SettingsButtonGray;
            SettingsButton.ForeColor = Color.DarkGray;

            mainUIStartup.BringToFront();

            checkForUpdatesButton.BringToFront();

            // High resolution button images handling
            HomeButton.Image = ResizeImageToFitButtonHeight(HomeButton.Image, (int)(HomeButton.Height * 0.7));
            OptimizationCatalogButton.Image = ResizeImageToFitButtonHeight(OptimizationCatalogButton.Image, (int)(OptimizationCatalogButton.Height * 0.7));
            checkForUpdatesButton.Image = ResizeImageToFitButtonHeight(checkForUpdatesButton.Image, (int)(checkForUpdatesButton.Height * 0.7));
            SupportAndHelpButton.Image = ResizeImageToFitButtonHeight(SupportAndHelpButton.Image, (int)(SupportAndHelpButton.Height * 0.7));
            GettingStartedButton.Image = ResizeImageToFitButtonHeight(GettingStartedButton.Image, (int)(GettingStartedButton.Height * 0.7));
            SettingsButton.Image = ResizeImageToFitButtonHeight(SettingsButton.Image, (int)(SettingsButton.Height * 0.7));

            socialsFacebook.Image = ResizeImageToFitButtonHeight(socialsFacebook.Image, (int)(socialsFacebook.Height * 0.7));
            socialsTwitter.Image = ResizeImageToFitButtonHeight(socialsTwitter.Image, (int)(socialsTwitter.Height * 0.7));
            socialsYouTube.Image = ResizeImageToFitButtonHeight(socialsYouTube.Image, (int)(socialsYouTube.Height * 0.7));

            premiumActivateTrialPanel.MouseEnter += premiumActivateMouseEnterTrialPanel;
            premiumActivateTrialPanel.MouseLeave += premiumActivateMouseLeaveTrialPanel;
            premiumActivateTrialPanel.MouseClick += premiumActivate_Click;

            premiumGetTrialPanel.MouseEnter += premiumGetMouseEnterTrialPanel;
            premiumGetTrialPanel.MouseLeave += premiumGetMouseLeaveTrialPanel;
            premiumGetTrialPanel.MouseClick += premiumGet_Click;

            continueToLSETrialPanel.MouseEnter += continueToLSEButtonMouseEnterTrialPanel;
            continueToLSETrialPanel.MouseLeave += continueToLSEButtonMouseLeaveTrialPanel;
            continueToLSETrialPanel.MouseClick += continueToLSETrialPanelMouseClick;

			label1.Text = "Your 14-day free trial has not yet been activated.";
			label3.Text = "Please re-launch the Low Specs Experience to activate your 14-day free trial.";
			continueToLSETrialPanel.Text = "Exit the Low Specs Experience";

			if (!Properties.Settings.Default.value_id_1335 || !Properties.Settings.Default.value_id_1336) // Trial period not active
			{
				DialogResult result = MessageBox.Show(
					"Thank you for installing Low Specs Experience.\n\nYou are about to activate your free 14-day trial.\n\nWould you like to continue?", 
					"Trial Period Activation", 
					MessageBoxButtons.YesNo, 
					MessageBoxIcon.Question
				);

				if (result == DialogResult.Yes)
				{
					Start();
					
					MessageBox.Show(
						"May your FPS be high and your temps be low!\n\n#HappyGaming :)", 
						"Trial Period Activated", 
						MessageBoxButtons.OK, 
						MessageBoxIcon.Information);
				}
				else
				{
					MessageBox.Show(
						"You can activate your free trial period on the next startup.", 
						"Trial Not Activated", 
						MessageBoxButtons.OK, 
						MessageBoxIcon.Exclamation
					);
					Environment.Exit(0); // Closes the application completely
				}
			}
			else // Trial period already active
			{
				Start();
			}
        }

        // Resize the image based on the button's height, maintaining the aspect ratio
        private Image ResizeImageToFitButtonHeight(Image image, int buttonHeight)
        {
            if (image == null) return null;  // Safety check

            // Calculate the aspect ratio of the original image
            double aspectRatio = (double)image.Width / image.Height;

            // Calculate the new width based on the button height and the aspect ratio
            int newWidth = (int)(buttonHeight * aspectRatio);

            // Resize the image with the new dimensions (new width and button height)
            var resizedImage = new Bitmap(image, new Size(newWidth, buttonHeight));

            return resizedImage;
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            Show();
            Activate();
            BringToFront();
        }

        private void LanguageChanger()
        {
            if (Properties.Settings.Default.AppSettings_Current_LangaugeBox == "Bosnian")
            {
                windowName = "Low Specs Experience";

                buttonName_Home = "              Početna";
                buttonName_OptimizationCatalog = "              Katalog Optimizacija";
                buttonName_CheckForUpdates = "              Provjeri Ažuriranja";
                buttonName_ContactSupport = "              Kontaktiraj Podršku";
                buttonName_GettingStarted = "              Pomoć za Početnike";
                buttonName_AppSettings = "              Postavke Aplikacije";

                messageExternalLinkRedirectQuestion = "Low Specs Experience će vas sada preusmjeriti na vanjski link koji će biti otvoren u vašem zadatom web pretraživaču. Da li želite nastaviti?";
                captionExternalLinkRedirectQuestion = "Preusmjeravanje na vanjski link";

                messageExternalLinkRedirectError = "Došlo je do greške prilikom obrade vašeg zahtjeva. Pokušajte ponoviti radnju tako što ćete prvo zatvoriti i ponovo pokrenuti Low Specs Experience ili kontaktirajte podršku za pomoć.";
                captionExternalLinkRedirectError = "Interna greška 201";

                messageCheckForUpdatesQuestionError = "Došlo je do greške prilikom obrade vašeg zahtjeva. Molimo provjerite da li ste povezani na internet i pokušajte ponovo ili kontaktirajte podršku za pomoć.";
                captionCheckForUpdatesQuestionError = "Interna greška 202";

                messageCheckForUpdatesQuestion = "Low Specs Experience će sada provjeriti da li je dostupna novija verzija. Da li želite nastaviti?";
                captionCheckForUpdatesQuestion = "Provjeri ažuriranja";

                messageCheckForUpdatesQuestionPermission = "Low Specs Experience zahtijeva administratorska prava za izvršenje ove radnje. Pokušajte ponovo pokrenuti Low Specs Experience kao administrator.";
                captionCheckForUpdatesQuestionPermission = "Potrebna administratorska prava";
            }

            if (Properties.Settings.Default.AppSettings_Current_LangaugeBox == "German")
            {
                windowName = "Low Specs Experience";

                buttonName_Home = "              Startseite";
                buttonName_OptimizationCatalog = "              Optimierungskatalog";
                buttonName_CheckForUpdates = "              Nach Updates suchen";
                buttonName_ContactSupport = "              Support kontaktieren";
                buttonName_GettingStarted = "              Erste Schritte";
                buttonName_AppSettings = "              App-Einstellungen";

                messageExternalLinkRedirectQuestion = "Low Specs Experience wird nun geöffnet und Sie zu einem externen Link in Ihrem Standard-Webbrowser weiterleiten. Möchten Sie fortfahren?";
                captionExternalLinkRedirectQuestion = "Externe Linkweiterleitung";

                messageExternalLinkRedirectError = "Ein interner Fehler ist aufgetreten, während Ihre Anfrage bearbeitet wurde. Bitte starten Sie Low Specs Experience neu und versuchen Sie es erneut oder kontaktieren Sie den Support.";
                captionExternalLinkRedirectError = "Interner Fehler 201";

                messageCheckForUpdatesQuestionError = "Ein interner Fehler ist aufgetreten, während Ihre Anfrage bearbeitet wurde. Bitte stellen Sie sicher, dass Sie mit dem Internet verbunden sind, starten Sie Low Specs Experience neu und versuchen Sie es erneut oder kontaktieren Sie den Support.";
                captionCheckForUpdatesQuestionError = "Interner Fehler 202";

                messageCheckForUpdatesQuestion = "Low Specs Experience wird nun überprüfen, ob eine neuere Version verfügbar ist. Möchten Sie fortfahren?";
                captionCheckForUpdatesQuestion = "Nach Updates suchen";

                messageCheckForUpdatesQuestionPermission = "Low Specs Experience erfordert Administratorrechte, um diese Aktion auszuführen. Bitte schließen Sie Low Specs Experience und führen Sie es als Administrator aus.";
                captionCheckForUpdatesQuestionPermission = "Administratorrechte erforderlich";
            }
        }

        private void SetUserInterfaceColor()
        {
            // Form back color
            this.BackColor = Color.FromArgb(Properties.Settings.Default.uiColor_BackgroundSeconaryR, Properties.Settings.Default.uiColor_BackgroundSeconaryG, Properties.Settings.Default.uiColor_BackgroundSeconaryB);
            MainUIButtons.BackColor = Color.FromArgb(Properties.Settings.Default.uiColor_BackgroundPrimaryR, Properties.Settings.Default.uiColor_BackgroundPrimaryG, Properties.Settings.Default.uiColor_BackgroundPrimaryB);

            // Label color
            /*
            foreach (Control control in this.Controls)
            {
                if (control is Label)
                {
                    Label label = (Label)control;
                    label.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorPrimaryR, Properties.Settings.Default.uiColor_ForeColorPrimaryG, Properties.Settings.Default.uiColor_ForeColorPrimaryB);
                }
            }
            */

            // Button color
            foreach (Control control in this.Controls)
            {
                // Check if the control is a Button
                if (control is Button)
                {
                    // Cast the control to Button and set its BackColor
                    Button button = (Button)control;
                    button.BackColor = Color.FromArgb(Properties.Settings.Default.uiColor_ButtonMainR, Properties.Settings.Default.uiColor_ButtonMainG, Properties.Settings.Default.uiColor_ButtonMainB);

                    // Optionally, set the ForeColor (text color) if desired
                    button.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorPrimaryR, Properties.Settings.Default.uiColor_ForeColorPrimaryG, Properties.Settings.Default.uiColor_ForeColorPrimaryB);
                }
            }

            // Drop-down boxes color
            foreach (Control control in this.Controls)
            {
                // Check if the control is a Button
                if (control is ComboBox)
                {
                    // Cast the control to Button and set its BackColor
                    ComboBox comboBox = (ComboBox)control;
                    comboBox.BackColor = Color.FromArgb(Properties.Settings.Default.uiColor_BackgroundAlternativeR, Properties.Settings.Default.uiColor_BackgroundAlternativeG, Properties.Settings.Default.uiColor_BackgroundAlternativeB);

                    // Optionally, set the ForeColor (text color) if desired
                    comboBox.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorPrimaryR, Properties.Settings.Default.uiColor_ForeColorPrimaryG, Properties.Settings.Default.uiColor_ForeColorPrimaryB);
                }
            }

            // List boxes color
            foreach (Control control in this.Controls)
            {
                // Check if the control is a Button
                if (control is ListBox)
                {
                    // Cast the control to Button and set its BackColor
                    ListBox listBox = (ListBox)control;
                    listBox.BackColor = Color.FromArgb(Properties.Settings.Default.uiColor_BackgroundAlternativeR, Properties.Settings.Default.uiColor_BackgroundAlternativeG, Properties.Settings.Default.uiColor_BackgroundAlternativeB);

                    // Optionally, set the ForeColor (text color) if desired
                    listBox.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorPrimaryR, Properties.Settings.Default.uiColor_ForeColorPrimaryG, Properties.Settings.Default.uiColor_ForeColorPrimaryB);
                }
            }

            // Text boxes color
            foreach (Control control in this.Controls)
            {
                // Check if the control is a Button
                if (control is TextBox)
                {
                    // Cast the control to Button and set its BackColor
                    TextBox textBox = (TextBox)control;
                    textBox.BackColor = Color.FromArgb(Properties.Settings.Default.uiColor_BackgroundAlternativeR, Properties.Settings.Default.uiColor_BackgroundAlternativeG, Properties.Settings.Default.uiColor_BackgroundAlternativeB);

                    // Optionally, set the ForeColor (text color) if desired
                    textBox.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorPrimaryR, Properties.Settings.Default.uiColor_ForeColorPrimaryG, Properties.Settings.Default.uiColor_ForeColorPrimaryB);
                }
            }

            // Trackbar color
            foreach (Control control in this.Controls)
            {
                // Check if the control is a Button
                if (control is TrackBar)
                {
                    // Cast the control to Button and set its BackColor
                    TrackBar trackBar = (TrackBar)control;
                    trackBar.BackColor = Color.FromArgb(Properties.Settings.Default.uiColor_BackgroundSeconaryR, Properties.Settings.Default.uiColor_BackgroundSeconaryG, Properties.Settings.Default.uiColor_BackgroundSeconaryB);
                }
            }

            // TextBox color
            foreach (Control control in this.Controls)
            {
                // Check if the control is a Button
                if (control is TextBox)
                {
                    // Cast the control to Button and set its BackColor
                    TextBox textBox = (TextBox)control;
                    textBox.BackColor = Color.FromArgb(Properties.Settings.Default.uiColor_ButtonMainR, Properties.Settings.Default.uiColor_ButtonMainG, Properties.Settings.Default.uiColor_ButtonMainB);

                    // Optionally, set the ForeColor (text color) if desired
                    textBox.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorPrimaryR, Properties.Settings.Default.uiColor_ForeColorPrimaryG, Properties.Settings.Default.uiColor_ForeColorPrimaryB);
                }
            }
        }

        private bool HomeButtonWasClicked = true;
        private bool OptimizationButtonWasClicked = false;
        private bool SupportButtonWasClicked = false;
        private bool GettingStartedButtonWasClicked = false;
        private bool SettingsButtonWasClicked = false;
        private bool CheckForUpdatesButtonWasClicked = false;
        // private bool ExitButtonWasClicked = false;

        //-------------------------------------------------
        // Controlls the premium activation and get premium buttons on trial panel
        //-------------------------------------------------
        private void premiumActivateMouseEnterTrialPanel(object sender, EventArgs e)
        {
            premiumActivateTrialPanel.BackColor = Color.Transparent;
            premiumActivateTrialPanel.FlatStyle = FlatStyle.Flat;
        }
        private void premiumActivateMouseLeaveTrialPanel(object sender, EventArgs e)
        {
            premiumActivateTrialPanel.BackColor = SystemColors.HotTrack;
            premiumActivateTrialPanel.FlatStyle = FlatStyle.Popup;
        }
        private void premiumGetMouseEnterTrialPanel(object sender, EventArgs e)
        {
            premiumGetTrialPanel.BackColor = Color.Transparent;
            premiumGetTrialPanel.FlatStyle = FlatStyle.Flat;
        }
        private void premiumGetMouseLeaveTrialPanel(object sender, EventArgs e)
        {
            premiumGetTrialPanel.BackColor = SystemColors.HotTrack;
            premiumGetTrialPanel.FlatStyle = FlatStyle.Popup;
        }

        private void continueToLSEButtonMouseEnterTrialPanel(object sender, EventArgs e)
        {
            continueToLSETrialPanel.BackColor = Color.Transparent;
            continueToLSETrialPanel.ForeColor = Color.White;
            continueToLSETrialPanel.FlatStyle = FlatStyle.Flat;
        }
        private void continueToLSEButtonMouseLeaveTrialPanel(object sender, EventArgs e)
        {
            continueToLSETrialPanel.BackColor = Color.FromArgb(Properties.Settings.Default.uiColor_ButtonMainR, Properties.Settings.Default.uiColor_ButtonMainG, Properties.Settings.Default.uiColor_ButtonMainB);
            continueToLSETrialPanel.ForeColor = Color.White;
            continueToLSETrialPanel.FlatStyle = FlatStyle.Popup;
        }

        //-------------------------------------------------
        // Controlls the premium activation and get premium buttons
        //-------------------------------------------------
        private void premiumActivateMouseEnter(object sender, EventArgs e)
        {
            premiumActivate.BackColor = Color.Transparent;
            premiumActivate.FlatStyle = FlatStyle.Flat;
        }
        private void premiumActivateMouseLeave(object sender, EventArgs e)
        {
            premiumActivate.BackColor = SystemColors.HotTrack;
            premiumActivate.FlatStyle = FlatStyle.Popup;
        }
        private void premiumGetMouseEnter(object sender, EventArgs e)
        {
            premiumGet.BackColor = Color.Transparent;
            premiumGet.FlatStyle = FlatStyle.Flat;
        }
        private void premiumGetMouseLeave(object sender, EventArgs e)
        {
            premiumGet.BackColor = SystemColors.HotTrack;
            premiumGet.FlatStyle = FlatStyle.Popup;
        }

        //-------------------------------------------------
        // Controlls the home button
        //-------------------------------------------------
        private void HomeButtonMouseEnter(object sender, EventArgs e)
        {
            HomeButton.BackColor = Color.Transparent;
            HomeButton.ForeColor = System.Drawing.Color.White;
            HomeButton.Image = Properties.Resources.HomeButtonWhite;

            // High resolution button images handling
            HomeButton.Image = ResizeImageToFitButtonHeight(HomeButton.Image, (int)(HomeButton.Height * 0.7));
            // OptimizationCatalogButton.Image = ResizeImageToFitButtonHeight(OptimizationCatalogButton.Image, (int)(OptimizationCatalogButton.Height * 0.7));
            // checkForUpdatesButton.Image = ResizeImageToFitButtonHeight(checkForUpdatesButton.Image, (int)(checkForUpdatesButton.Height * 0.7));
            // SupportAndHelpButton.Image = ResizeImageToFitButtonHeight(SupportAndHelpButton.Image, (int)(SupportAndHelpButton.Height * 0.7));
            // GettingStartedButton.Image = ResizeImageToFitButtonHeight(GettingStartedButton.Image, (int)(GettingStartedButton.Height * 0.7));
            // SettingsButton.Image = ResizeImageToFitButtonHeight(SettingsButton.Image, (int)(SettingsButton.Height * 0.7));
        }
        private void HomeButtonMouseLeave(object sender, EventArgs e)
        {
            HomeButton.BackColor = Color.Transparent;

            // Button setup controller
            buttonSetup();
        }

        private void HomeButtonMouseClick(object sender, EventArgs e)
        {
            HomeButton.BackColor = Color.Transparent;
            HomeButton.ForeColor = System.Drawing.Color.White;
            HomeButton.Image = Properties.Resources.HomeButtonWhite;
            HomeButtonWasClicked = true;
            OptimizationButtonWasClicked = false;
            SupportButtonWasClicked = false;
            GettingStartedButtonWasClicked = false;
            SettingsButtonWasClicked = false;
            CheckForUpdatesButtonWasClicked = false;

            // Button setup controller
            buttonSetup();
        }

        //-------------------------------------------------
        // Controlls the optimization catalog button
        //-------------------------------------------------
        private void OptimizationCatalogButtonMouseEnter(object sender, EventArgs e)
        {
            OptimizationCatalogButton.BackColor = Color.Transparent;
            OptimizationCatalogButton.ForeColor = System.Drawing.Color.White;
            OptimizationCatalogButton.Image = Properties.Resources.OptimizeButtonWhite;

            // High resolution button images handling
            // HomeButton.Image = ResizeImageToFitButtonHeight(HomeButton.Image, (int)(HomeButton.Height * 0.7));
            OptimizationCatalogButton.Image = ResizeImageToFitButtonHeight(OptimizationCatalogButton.Image, (int)(OptimizationCatalogButton.Height * 0.7));
            // checkForUpdatesButton.Image = ResizeImageToFitButtonHeight(checkForUpdatesButton.Image, (int)(checkForUpdatesButton.Height * 0.7));
            // SupportAndHelpButton.Image = ResizeImageToFitButtonHeight(SupportAndHelpButton.Image, (int)(SupportAndHelpButton.Height * 0.7));
            // GettingStartedButton.Image = ResizeImageToFitButtonHeight(GettingStartedButton.Image, (int)(GettingStartedButton.Height * 0.7));
            // SettingsButton.Image = ResizeImageToFitButtonHeight(SettingsButton.Image, (int)(SettingsButton.Height * 0.7));
        }
        private void OptimizationCatalogButtonMouseLeave(object sender, EventArgs e)
        {
            OptimizationCatalogButton.BackColor = Color.Transparent;

            // Button setup controller
            buttonSetup();
        }

        private void OptimizationCatalogButtonMouseClick(object sender, EventArgs e)
        {
            OptimizationCatalogButton.BackColor = Color.Transparent;
            OptimizationCatalogButton.ForeColor = System.Drawing.Color.White;
            OptimizationCatalogButton.Image = Properties.Resources.OptimizeButtonWhite;
            HomeButtonWasClicked = false;
            OptimizationButtonWasClicked = true;
            SupportButtonWasClicked = false;
            GettingStartedButtonWasClicked = false;
            SettingsButtonWasClicked = false;
            CheckForUpdatesButtonWasClicked = false;

            // Button setup controller
            buttonSetup();
        }

        //-------------------------------------------------
        // Controlls the support button
        //-------------------------------------------------
        private void SupportButtonMouseEnter(object sender, EventArgs e)
        {
            SupportAndHelpButton.BackColor = Color.Transparent;
            SupportAndHelpButton.ForeColor = System.Drawing.Color.White;
            SupportAndHelpButton.Image = Properties.Resources.SupportButtonWhite;

            // High resolution button images handling
            // HomeButton.Image = ResizeImageToFitButtonHeight(HomeButton.Image, (int)(HomeButton.Height * 0.7));
            // OptimizationCatalogButton.Image = ResizeImageToFitButtonHeight(OptimizationCatalogButton.Image, (int)(OptimizationCatalogButton.Height * 0.7));
            // checkForUpdatesButton.Image = ResizeImageToFitButtonHeight(checkForUpdatesButton.Image, (int)(checkForUpdatesButton.Height * 0.7));
            SupportAndHelpButton.Image = ResizeImageToFitButtonHeight(SupportAndHelpButton.Image, (int)(SupportAndHelpButton.Height * 0.7));
            // GettingStartedButton.Image = ResizeImageToFitButtonHeight(GettingStartedButton.Image, (int)(GettingStartedButton.Height * 0.7));
            // SettingsButton.Image = ResizeImageToFitButtonHeight(SettingsButton.Image, (int)(SettingsButton.Height * 0.7));
        }
        private void SupportButtonMouseLeave(object sender, EventArgs e)
        {
            SupportAndHelpButton.BackColor = Color.Transparent;

            // Button setup controller
            buttonSetup();
        }

        private void SupportButtonMouseClick(object sender, EventArgs e)
        {
            SupportAndHelpButton.BackColor = Color.Transparent;
            SupportAndHelpButton.ForeColor = System.Drawing.Color.White;
            SupportAndHelpButton.Image = Properties.Resources.SupportButtonWhite;
            HomeButtonWasClicked = false;
            OptimizationButtonWasClicked = false;
            SupportButtonWasClicked = true;
            GettingStartedButtonWasClicked = false;
            SettingsButtonWasClicked = false;
            CheckForUpdatesButtonWasClicked = false;

            // Button setup controller
            buttonSetup();
        }

        //-------------------------------------------------
        // Controlls the getting started button
        //-------------------------------------------------
        private void GettingStartedButtonMouseEnter(object sender, EventArgs e)
        {
            GettingStartedButton.BackColor = Color.Transparent;
            GettingStartedButton.ForeColor = System.Drawing.Color.White;
            GettingStartedButton.Image = Properties.Resources.GettingStartedWhite;

            // High resolution button images handling
            // HomeButton.Image = ResizeImageToFitButtonHeight(HomeButton.Image, (int)(HomeButton.Height * 0.7));
            // OptimizationCatalogButton.Image = ResizeImageToFitButtonHeight(OptimizationCatalogButton.Image, (int)(OptimizationCatalogButton.Height * 0.7));
            // checkForUpdatesButton.Image = ResizeImageToFitButtonHeight(checkForUpdatesButton.Image, (int)(checkForUpdatesButton.Height * 0.7));
            // SupportAndHelpButton.Image = ResizeImageToFitButtonHeight(SupportAndHelpButton.Image, (int)(SupportAndHelpButton.Height * 0.7));
            GettingStartedButton.Image = ResizeImageToFitButtonHeight(GettingStartedButton.Image, (int)(GettingStartedButton.Height * 0.7));
            // SettingsButton.Image = ResizeImageToFitButtonHeight(SettingsButton.Image, (int)(SettingsButton.Height * 0.7));
        }
        private void GettingStartedButtonMouseLeave(object sender, EventArgs e)
        {
            GettingStartedButton.BackColor = Color.Transparent;

            // Button setup controller
            buttonSetup();
        }

        private void GettingStartedButtonMouseClick(object sender, EventArgs e)
        {
            GettingStartedButton.BackColor = Color.Transparent;
            GettingStartedButton.ForeColor = System.Drawing.Color.White;
            GettingStartedButton.Image = Properties.Resources.GettingStartedWhite;
            HomeButtonWasClicked = false;
            OptimizationButtonWasClicked = false;
            SupportButtonWasClicked = false;
            GettingStartedButtonWasClicked = true;
            SettingsButtonWasClicked = false;
            CheckForUpdatesButtonWasClicked = false;

            // Button setup controller
            buttonSetup();
        }

        //-------------------------------------------------
        // Controlls the settings button
        //-------------------------------------------------
        private void SettingsButtonMouseEnter(object sender, EventArgs e)
        {
            SettingsButton.BackColor = Color.Transparent;
            SettingsButton.ForeColor = System.Drawing.Color.White;
            SettingsButton.Image = Properties.Resources.SettingsButtonWhite;

            // High resolution button images handling
            // HomeButton.Image = ResizeImageToFitButtonHeight(HomeButton.Image, (int)(HomeButton.Height * 0.7));
            // OptimizationCatalogButton.Image = ResizeImageToFitButtonHeight(OptimizationCatalogButton.Image, (int)(OptimizationCatalogButton.Height * 0.7));
            // checkForUpdatesButton.Image = ResizeImageToFitButtonHeight(checkForUpdatesButton.Image, (int)(checkForUpdatesButton.Height * 0.7));
            // SupportAndHelpButton.Image = ResizeImageToFitButtonHeight(SupportAndHelpButton.Image, (int)(SupportAndHelpButton.Height * 0.7));
            // GettingStartedButton.Image = ResizeImageToFitButtonHeight(GettingStartedButton.Image, (int)(GettingStartedButton.Height * 0.7));
            SettingsButton.Image = ResizeImageToFitButtonHeight(SettingsButton.Image, (int)(SettingsButton.Height * 0.7));
        }
        private void SettingsButtonMouseLeave(object sender, EventArgs e)
        {
            SettingsButton.BackColor = Color.Transparent;

            // Button setup controller
            buttonSetup();
        }

        private void SettingsButtonMouseClick(object sender, EventArgs e)
        {
            SettingsButton.BackColor = Color.Transparent;
            SettingsButton.ForeColor = System.Drawing.Color.White;
            SettingsButton.Image = Properties.Resources.SettingsButtonWhite;
            HomeButtonWasClicked = false;
            OptimizationButtonWasClicked = false;
            SupportButtonWasClicked = false;
            GettingStartedButtonWasClicked = false;
            SettingsButtonWasClicked = false;
            CheckForUpdatesButtonWasClicked = false;

            // Button setup controller
            buttonSetup();
        }

        //-------------------------------------------------
        // Controlls the update button
        //-------------------------------------------------
        private void checkForUpdatesButtonMouseEnter(object sender, EventArgs e)
        {
            checkForUpdatesButton.BackColor = Color.Transparent;
            checkForUpdatesButton.ForeColor = System.Drawing.Color.White;
            checkForUpdatesButton.Image = Properties.Resources.UpdatesButtonWhite;

            // High resolution button images handling
            // HomeButton.Image = ResizeImageToFitButtonHeight(HomeButton.Image, (int)(HomeButton.Height * 0.7));
            // OptimizationCatalogButton.Image = ResizeImageToFitButtonHeight(OptimizationCatalogButton.Image, (int)(OptimizationCatalogButton.Height * 0.7));
            checkForUpdatesButton.Image = ResizeImageToFitButtonHeight(checkForUpdatesButton.Image, (int)(checkForUpdatesButton.Height * 0.7));
            // SupportAndHelpButton.Image = ResizeImageToFitButtonHeight(SupportAndHelpButton.Image, (int)(SupportAndHelpButton.Height * 0.7));
            // GettingStartedButton.Image = ResizeImageToFitButtonHeight(GettingStartedButton.Image, (int)(GettingStartedButton.Height * 0.7));
            // SettingsButton.Image = ResizeImageToFitButtonHeight(SettingsButton.Image, (int)(SettingsButton.Height * 0.7));
        }
        private void checkForUpdatesButtonMouseLeave(object sender, EventArgs e)
        {
            checkForUpdatesButton.BackColor = Color.Transparent;

            // Button setup controller
            buttonSetup();
        }

        private void checkForUpdatesButtonMouseClick(object sender, EventArgs e)
        {
            checkForUpdatesButton.BackColor = Color.Transparent;
            checkForUpdatesButton.ForeColor = System.Drawing.Color.White;
            checkForUpdatesButton.Image = Properties.Resources.UpdatesButtonWhite;
            HomeButtonWasClicked = false;
            OptimizationButtonWasClicked = false;
            SupportButtonWasClicked = false;
            GettingStartedButtonWasClicked = false;
            SettingsButtonWasClicked = false;
            CheckForUpdatesButtonWasClicked = true;

            // Button setup controller
            buttonSetup();
        }

        //-------------------------------------------------
        // Controlls the Facebook social link
        //-------------------------------------------------
        private void socialsFacebookMouseEnter(object sender, EventArgs e)
        {
            socialsFacebook.BackColor = Color.Transparent;
            socialsFacebook.Image = Properties.Resources.socialsFacebookWhite;

            socialsFacebook.Image = ResizeImageToFitButtonHeight(socialsFacebook.Image, (int)(socialsFacebook.Height * 0.7));
            // socialsTwitter.Image = ResizeImageToFitButtonHeight(socialsTwitter.Image, (int)(socialsTwitter.Height * 0.7));
            // socialsYouTube.Image = ResizeImageToFitButtonHeight(socialsYouTube.Image, (int)(socialsYouTube.Height * 0.7));
        }
        private void socialsFacebookMouseLeave(object sender, EventArgs e)
        {
            socialsFacebook.Image = Properties.Resources.socialsFacebookGray;

            socialsFacebook.Image = ResizeImageToFitButtonHeight(socialsFacebook.Image, (int)(socialsFacebook.Height * 0.7));
            // socialsTwitter.Image = ResizeImageToFitButtonHeight(socialsTwitter.Image, (int)(socialsTwitter.Height * 0.7));
            // socialsYouTube.Image = ResizeImageToFitButtonHeight(socialsYouTube.Image, (int)(socialsYouTube.Height * 0.7));
        }

        //-------------------------------------------------
        // Controlls the Twitter social link
        //-------------------------------------------------
        private void socialsTwitterMouseEnter(object sender, EventArgs e)
        {
            socialsTwitter.BackColor = Color.Transparent;
            socialsTwitter.Image = Properties.Resources.socialsTwitterWhite;

            // socialsFacebook.Image = ResizeImageToFitButtonHeight(socialsFacebook.Image, (int)(socialsFacebook.Height * 0.7));
            socialsTwitter.Image = ResizeImageToFitButtonHeight(socialsTwitter.Image, (int)(socialsTwitter.Height * 0.7));
            // socialsYouTube.Image = ResizeImageToFitButtonHeight(socialsYouTube.Image, (int)(socialsYouTube.Height * 0.7));
        }
        private void socialsTwitterMouseLeave(object sender, EventArgs e)
        {
            socialsTwitter.Image = Properties.Resources.socialsTwitterGray;

            // socialsFacebook.Image = ResizeImageToFitButtonHeight(socialsFacebook.Image, (int)(socialsFacebook.Height * 0.7));
            socialsTwitter.Image = ResizeImageToFitButtonHeight(socialsTwitter.Image, (int)(socialsTwitter.Height * 0.7));
            // socialsYouTube.Image = ResizeImageToFitButtonHeight(socialsYouTube.Image, (int)(socialsYouTube.Height * 0.7));
        }

        //-------------------------------------------------
        // Controlls the YouTube social link
        //-------------------------------------------------
        private void socialsYouTubeMouseEnter(object sender, EventArgs e)
        {
            socialsYouTube.BackColor = Color.Transparent;
            socialsYouTube.Image = Properties.Resources.socialsYouTubeWhite;

            // socialsFacebook.Image = ResizeImageToFitButtonHeight(socialsFacebook.Image, (int)(socialsFacebook.Height * 0.7));
            // socialsTwitter.Image = ResizeImageToFitButtonHeight(socialsTwitter.Image, (int)(socialsTwitter.Height * 0.7));
            socialsYouTube.Image = ResizeImageToFitButtonHeight(socialsYouTube.Image, (int)(socialsYouTube.Height * 0.7));
        }
        private void socialsYouTubeMouseLeave(object sender, EventArgs e)
        {
            socialsYouTube.Image = Properties.Resources.SocialsYouTubeGray;

            // socialsFacebook.Image = ResizeImageToFitButtonHeight(socialsFacebook.Image, (int)(socialsFacebook.Height * 0.7));
            // socialsTwitter.Image = ResizeImageToFitButtonHeight(socialsTwitter.Image, (int)(socialsTwitter.Height * 0.7));
            socialsYouTube.Image = ResizeImageToFitButtonHeight(socialsYouTube.Image, (int)(socialsYouTube.Height * 0.7));
        }

        public void buttonSetup()
        {
            {
                if (HomeButtonWasClicked == true)
                {
                    HomeButton.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorHoverR, Properties.Settings.Default.uiColor_ForeColorHoverG, Properties.Settings.Default.uiColor_ForeColorHoverB);
                    HomeButton.Image = Properties.Resources.HomeButtonWhite;
                    HomeButtonWasClicked = true;
                }
                else
                {
                    HomeButton.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorHoverAlternativeR, Properties.Settings.Default.uiColor_ForeColorHoverAlternativeG, Properties.Settings.Default.uiColor_ForeColorHoverAlternativeB);
                    HomeButton.Image = Properties.Resources.HomeButtonGray;
                    HomeButtonWasClicked = false;
                }

                if (OptimizationButtonWasClicked == true)
                {
                    OptimizationCatalogButton.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorHoverR, Properties.Settings.Default.uiColor_ForeColorHoverG, Properties.Settings.Default.uiColor_ForeColorHoverB);
                    OptimizationCatalogButton.Image = Properties.Resources.OptimizeButtonWhite;
                    OptimizationButtonWasClicked = true;
                }
                else
                {
                    OptimizationCatalogButton.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorHoverAlternativeR, Properties.Settings.Default.uiColor_ForeColorHoverAlternativeG, Properties.Settings.Default.uiColor_ForeColorHoverAlternativeB);
                    OptimizationCatalogButton.Image = Properties.Resources.OptimizeButtonGray;
                    OptimizationButtonWasClicked = false;
                }

                if (SupportButtonWasClicked == true)
                {
                    SupportAndHelpButton.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorHoverR, Properties.Settings.Default.uiColor_ForeColorHoverG, Properties.Settings.Default.uiColor_ForeColorHoverB);
                    SupportAndHelpButton.Image = Properties.Resources.SupportButtonWhite;
                    SupportButtonWasClicked = true;
                }
                else
                {
                    SupportAndHelpButton.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorHoverAlternativeR, Properties.Settings.Default.uiColor_ForeColorHoverAlternativeG, Properties.Settings.Default.uiColor_ForeColorHoverAlternativeB);
                    SupportAndHelpButton.Image = Properties.Resources.SupportButtonGray;
                    SupportButtonWasClicked = false;
                }

                if (GettingStartedButtonWasClicked == true)
                {
                    GettingStartedButton.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorHoverR, Properties.Settings.Default.uiColor_ForeColorHoverG, Properties.Settings.Default.uiColor_ForeColorHoverB);
                    GettingStartedButton.Image = Properties.Resources.GettingStartedWhite;
                    GettingStartedButtonWasClicked = true;
                }
                else
                {
                    GettingStartedButton.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorHoverAlternativeR, Properties.Settings.Default.uiColor_ForeColorHoverAlternativeG, Properties.Settings.Default.uiColor_ForeColorHoverAlternativeB);
                    GettingStartedButton.Image = Properties.Resources.GettingStartedGray;
                    GettingStartedButtonWasClicked = false;
                }

                if (SettingsButtonWasClicked == true)
                {
                    SettingsButton.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorHoverR, Properties.Settings.Default.uiColor_ForeColorHoverG, Properties.Settings.Default.uiColor_ForeColorHoverB);
                    SettingsButton.Image = Properties.Resources.SettingsButtonWhite;
                    SettingsButtonWasClicked = true;
                }
                else
                {
                    SettingsButton.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorHoverAlternativeR, Properties.Settings.Default.uiColor_ForeColorHoverAlternativeG, Properties.Settings.Default.uiColor_ForeColorHoverAlternativeB);
                    SettingsButton.Image = Properties.Resources.SettingsButtonGray;
                    SettingsButtonWasClicked = false;
                }

                if (CheckForUpdatesButtonWasClicked == true)
                {
                    checkForUpdatesButton.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorHoverR, Properties.Settings.Default.uiColor_ForeColorHoverG, Properties.Settings.Default.uiColor_ForeColorHoverB);
                    checkForUpdatesButton.Image = Properties.Resources.UpdatesButtonWhite;
                    CheckForUpdatesButtonWasClicked = true;
                }
                else
                {
                    checkForUpdatesButton.ForeColor = Color.FromArgb(Properties.Settings.Default.uiColor_ForeColorHoverAlternativeR, Properties.Settings.Default.uiColor_ForeColorHoverAlternativeG, Properties.Settings.Default.uiColor_ForeColorHoverAlternativeB);
                    checkForUpdatesButton.Image = Properties.Resources.UpdatesButtonGray;
                    CheckForUpdatesButtonWasClicked = false;
                }

                // High resolution button images handling
                HomeButton.Image = ResizeImageToFitButtonHeight(HomeButton.Image, (int)(HomeButton.Height * 0.7));
                OptimizationCatalogButton.Image = ResizeImageToFitButtonHeight(OptimizationCatalogButton.Image, (int)(OptimizationCatalogButton.Height * 0.7));
                checkForUpdatesButton.Image = ResizeImageToFitButtonHeight(checkForUpdatesButton.Image, (int)(checkForUpdatesButton.Height * 0.7));
                SupportAndHelpButton.Image = ResizeImageToFitButtonHeight(SupportAndHelpButton.Image, (int)(SupportAndHelpButton.Height * 0.7));
                GettingStartedButton.Image = ResizeImageToFitButtonHeight(GettingStartedButton.Image, (int)(GettingStartedButton.Height * 0.7));
                SettingsButton.Image = ResizeImageToFitButtonHeight(SettingsButton.Image, (int)(SettingsButton.Height * 0.7));
            }
        }

        // ---------------------------------------------
        // USELESS DECOY CODE --- START
        // ---------------------------------------------
        private void CheckTrialPeriodStatus()
        {
            try
            {
                if (!Directory.Exists(trChecker0))
                {
                    Directory.CreateDirectory(trChecker0);
                    File.CreateText(trChecker);
                }

                if (!Directory.Exists(trCheckerAlt0))
                {
                    Directory.CreateDirectory(trCheckerAlt0);
                    File.CreateText(trCheckerAlt);
                }

                if (!Directory.Exists(trCherckerAltt0))
                {
                    Directory.CreateDirectory(trCherckerAltt0);
                    File.CreateText(trCherckerAltt);
                }
            }
            catch
            {

            }

            if (File.Exists(trChecker))
            {
                file = trChecker;
            }
            else
            {
                if (File.Exists(trCheckerAlt))
                {
                    file = trCheckerAlt;
                }
                else
                {
                    if (File.Exists(trCherckerAltt))
                    {
                        file = trCherckerAltt;
                    }
                    else
                    {

                    }
                }
            }

            if (File.Exists(file))
            {
                FileInfo fileInfo = new FileInfo(file);
                DateTime lastWriteTime = fileInfo.LastWriteTime;

                dateStringExpires = lastWriteTime.AddDays(+14).ToString();

                // If trial expired DO; else ignore and do something else
                if (fileInfo.LastWriteTime < DateTime.Now.AddDays(-14))
                {
                    component = 2;
                }
                else
                {
                    component = 1;
                }
            }
            else
            {
                if (File.Exists(trCheckerManip))
                {
                    Random random = new Random();
                    string alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
                    string randomLetters = "";

                    for (int i = 0; i < 3; i++)
                    {
                        randomLetters += alphabet[random.Next(alphabet.Length)];
                    }

                    string errorCode = "ATP-" + randomLetters;

                    MessageBox.Show("Error code: " + errorCode, "License Tampering Detected!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    Application.Exit();
                }
                else
                {
                    DirectoryInfo directoryInfo = new DirectoryInfo(trCherckerAltt0);
                    DateTime lastWriteTime = directoryInfo.LastWriteTime;

                    dateStringExpires = lastWriteTime.AddDays(+14).ToString();

                    // If trial expired DO; else ignore and do something else
                    if (directoryInfo.LastWriteTime < DateTime.Now.AddDays(-14))
                    {
                        component = 2;
                    }
                    else
                    {
                        component = 1;
                    }
                }
            }
            uiShifter();

            trialActivation1.Location = new Point(1, -1);
            trialActivation1.BringToFront();
        }

        // ---------------------------------------------
        // USELESS DECOY CODE --- END
        // ---------------------------------------------

        // ---------------------------------------------
        // 2024-Q4 Anti-Tampering System
        // ---------------------------------------------

        public void Start()
        {
            // Assign current date and time
            installationDate = DateTime.UtcNow;
            expirationDate = DateTime.UtcNow.AddDays(+14);

           try
           {
               errReport = "Alpha: X-01";

               component = 1;

               // installationDate = Properties.Settings.Default.date1;

               // string installationDateString = Properties.Settings.Default.date1.ToString();

               errReport = "Echo: X-01";

               // Set installationDate if it is null or empty
                if (Properties.Settings.Default.value_id_1335 == false) // if (string.IsNullOrEmpty(installationDateString))
                {
                    // Decoy user_sett_calc values just because
                    Properties.Settings.Default.user_sett_calc_se = ((DateTimeOffset)installationDate).ToUnixTimeSeconds() + 86400;
                    Properties.Settings.Default.user_sett_calc_vs = ((DateTimeOffset)installationDate).ToUnixTimeSeconds() + 172800;
                    Properties.Settings.Default.user_sett_calc_gf = ((DateTimeOffset)installationDate).ToUnixTimeSeconds() + 259200;
                    Properties.Settings.Default.user_sett_calc_gf = ((DateTimeOffset)installationDate).ToUnixTimeSeconds() + 345600;
                    Properties.Settings.Default.user_sett_calc_iw = ((DateTimeOffset)installationDate).ToUnixTimeSeconds() + 432000;
                    Properties.Settings.Default.user_sett_calc_ss = ((DateTimeOffset)installationDate).ToUnixTimeSeconds() + 518400;
                    Properties.Settings.Default.user_sett_calc_ok = ((DateTimeOffset)installationDate).ToUnixTimeSeconds() + 604800;
                    Properties.Settings.Default.user_sett_calc_ab = ((DateTimeOffset)installationDate).ToUnixTimeSeconds() + 681200;
                    Properties.Settings.Default.user_sett_calc_ts = ((DateTimeOffset)installationDate).ToUnixTimeSeconds() + 777600;
                    Properties.Settings.Default.user_sett_calc_ds = ((DateTimeOffset)installationDate).ToUnixTimeSeconds() + 864000;
                    Properties.Settings.Default.user_sett_calc_lo = ((DateTimeOffset)installationDate).ToUnixTimeSeconds() + 950400;

                    // True user_sett_calc values
                    Properties.Settings.Default.user_sett_calc_sh = ((DateTimeOffset)installationDate).ToUnixTimeSeconds();
                    Properties.Settings.Default.value_id_1335 = true;
                    Properties.Settings.Default.Save();
                }

                errReport = "Echo: X-02";

                if (!Directory.Exists(Path.GetDirectoryName(configFilePath)))
                {
                    Directory.CreateDirectory(Path.GetDirectoryName(configFilePath));
                }

                errReport = "Echo: X-03";

                if (!File.Exists(configFilePath))
                {
                    File.WriteAllText(configFilePath, ((DateTimeOffset)installationDate).ToUnixTimeSeconds().ToString());
                }

                errReport = "Echo: X-04";

                // Set trialExpiresDate if it is null or empty
                if (Properties.Settings.Default.value_id_1336 == false) // if (string.IsNullOrEmpty(expirationDateString))
                {
                    Properties.Settings.Default.user_sett_calc_cp = ((DateTimeOffset)expirationDate).ToUnixTimeSeconds();
                    Properties.Settings.Default.value_id_1336 = true;
                    Properties.Settings.Default.Save();
                }

                errReport = "Echo: X-05";

                // Store trialExpiresDate in a local file if the file doesn't exist
                if (!File.Exists(configFilePathAlt))
                {
                    File.WriteAllText(configFilePathAlt, ((DateTimeOffset)expirationDate).ToUnixTimeSeconds().ToString());
                }

                errReport = "Echo: X-06";

                string registryDate1 = File.ReadAllText(configFilePath);
                string registryDate2 = File.ReadAllText(configFilePathAlt);

                DateTime parsedDate1;
                DateTime parsedDate2;

                // Method to convert Unix timestamp to DateTime
                DateTime UnixTimeStampToDateTime(long unixTimeStamp)
                {
                    // Unix timestamp is seconds past epoch
                    DateTimeOffset dateTimeOffset = DateTimeOffset.FromUnixTimeSeconds(unixTimeStamp);
                    return dateTimeOffset.UtcDateTime;
                }

                // Try to parse the first registry date
                if (long.TryParse(registryDate1, out long unixTimestamp1))
                {
                    parsedDate1 = UnixTimeStampToDateTime(unixTimestamp1);
                    // Now parsedDate1 contains the correct DateTime value
                }
                else
                {
                    // Parsing failed, setting to DateTime.MinValue
                    parsedDate1 = DateTime.MinValue;
                }

                // Try to parse the second registry date
                if (long.TryParse(registryDate2, out long unixTimestamp2))
                {
                    parsedDate2 = UnixTimeStampToDateTime(unixTimestamp2);
                    // Now parsedDate2 contains the correct DateTime value
                }
                else
                {
                    // Parsing failed, setting to DateTime.MinValue
                    parsedDate2 = DateTime.MinValue;
                }

                DateTime dateOne = DateTimeOffset.FromUnixTimeSeconds(Properties.Settings.Default.user_sett_calc_sh).UtcDateTime;
                DateTime dateTwo = DateTimeOffset.FromUnixTimeSeconds(Properties.Settings.Default.user_sett_calc_cp).UtcDateTime;

                DateTime dateOneBackup = parsedDate1;
                DateTime dateTwoBackup = parsedDate2;

                errReport = "Echo: X-07";

                if (DateTime.Equals(dateOne, dateOneBackup))
                {
                    trialTamperProtectionA = false;
                }
                else
                {
                    trialTamperProtectionA = true;
                }

                errReport = "Echo: X-08";

                if (DateTime.Equals(dateTwo, dateTwoBackup))
                {
                    trialTamperProtectionB = false;
                }
                else
                {
                    trialTamperProtectionB = true;
                }

                if (trialTamperProtectionA || trialTamperProtectionB)
                {
                    trialTamperProtectionFinal = true;
                }
                else
                {
                    trialTamperProtectionFinal = false;
                }

                errReport = "Sierra: X-01";

                if (trialTamperProtectionFinal == false)
                {
                    // Parse the date strings from Properties.Settings.Default
                    DateTime date1c = DateTimeOffset.FromUnixTimeSeconds(Properties.Settings.Default.user_sett_calc_sh).UtcDateTime; // DateTime date1c = DateTime.Parse(Properties.Settings.Default.date1);
                    DateTime date2c = DateTimeOffset.FromUnixTimeSeconds(Properties.Settings.Default.user_sett_calc_cp).UtcDateTime; // DateTime date2c = DateTime.Parse(Properties.Settings.Default.date2);

                    // Get the current date and time
                    DateTime now = DateTime.UtcNow;

                    // Check if the current date is outside the range
                    bool isOutsideRange = now < date1c || now > date2c;

                    // Set trialTamperProtectionFinal based on the result
                    trialTamperProtectionFinal = isOutsideRange;
                }

                errReport = "Sierra: X-02";

                if (trialTamperProtectionFinal == true)
                {
                    // MessageBox.Show("Tampering detected.");

                    if (!File.Exists(ksFilePath))
                    {
                        File.Create(ksFilePath).Close();
                        File.WriteAllText(ksFilePath, "true");
                    }

                    errReport = "Sierra: X-03";

                    Properties.Settings.Default.ks0 = true;
                    Properties.Settings.Default.Save();

                    errReport = "Sierra: X-04";

                    string filePath = configFilePathManipPathF;

                    if (!File.Exists(filePath))
                    {
                        Directory.CreateDirectory(Path.GetDirectoryName(filePath));
                        File.Create(filePath).Close();
                    }

                    component = 2;
                }
                else
                {
                    // MessageBox.Show("true je", "");
                }

                errReport = "Sierra: X-05";

                if (File.Exists(ksFilePath))
                {
                    fileContent = File.ReadAllText(ksFilePath);
                }
                else
                {
                    fileContent = "false";
                }

                errReport = "Sierra: X-06";

                if (File.Exists(configFilePathManipPathF)
                    || fileContent.Contains("true")
                    || Properties.Settings.Default.ks0)
                {

                    errReport = "Sierra: X-07";

                    if (!File.Exists(ksFilePath))
                    {
                        File.WriteAllText(ksFilePath, "true");
                    }
                    else
                    {
                        File.WriteAllText(ksFilePath, "true");
                    }

                    string filePath = configFilePathManipPathF;

                    errReport = "Sierra: X-08";

                    if (!File.Exists(filePath))
					{
						// Create the directory if it doesn't exist
						Directory.CreateDirectory(Path.GetDirectoryName(filePath));
						
						// Create the file and write "Code: 1" to it
						File.WriteAllText(filePath, "Code: 1");
					}
					
					errReport = "Sierra: X-09";

                    Properties.Settings.Default.ks0 = true;
                    Properties.Settings.Default.Save();

                    // MessageBox.Show("Tampering detected.");
                    component = 2;
                }

                FetchUnixTimeAsync();	// Runs only if component IS NOT 2 (expired)
            }
            catch // (Exception ex)
            {
                // Display error message box
                MessageBox.Show(
                    "Low Specs Experience has encountered a fatal error and now must close. If you keep seeing this message, please contact the support via email at support@ragnotechpowered.com and include the following error code: " + errReport,
                    "Fatal Error Occurred",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error
                );

                // Terminate the application

                component = 2;
                Environment.Exit(0);

                // Handle the exception here
                // Console.WriteLine("An error occurred: " + ex.Message);
            }
			
            uiShifter();

            trialActivation1.Location = new Point(1, -1);
            trialActivation1.BringToFront();
        }

        // ---------------------------------------------
        // UNFINISHED ANTI-TAMPER PROTECTION
        // ---------------------------------------------

        public void CheckTrialStatusA()
        {
            component = 1;

            // Check if directories and files exist, create them if not
            CheckAndCreateDirectory(Path.GetDirectoryName(strtpcntrA));
            CheckAndCreateDirectory(Path.GetDirectoryName(strtpcntrAltA));
            CheckAndCreateDirectory(Path.GetDirectoryName(nstldtstrA));
            CheckAndCreateDirectory(Path.GetDirectoryName(nstldtstrAltA));
            CheckAndCreateFile(strtpcntrA);
            CheckAndCreateFile(strtpcntrAltA);
            CheckAndCreateFile(nstldtstrA, DateTime.Now.AddDays(14).ToString());
            CheckAndCreateFile(nstldtstrAltA, DateTime.Now.AddDays(14).ToString());

            // Store DateTime.Now in date1 key
            Registry.CurrentUser.CreateSubKey(@"Software\Manip Solutions")?.SetValue("date1", DateTime.Now.ToBinary());

            // Store DateTime.Now + 14 days in date2 key
            Registry.CurrentUser.CreateSubKey(@"Software\Manip Solutions")?.SetValue("date2", DateTime.Now.AddDays(14).ToBinary());

            // Read and compare dates from files and registry
            DateTime strtpcntrDate = ReadDateFromFile(strtpcntr);
            DateTime strtpcntrAltDate = ReadDateFromFile(strtpcntrAlt);
            DateTime nstldtstrDate = ReadDateFromFile(nstldtstr);
            DateTime nstldtstrAltDate = ReadDateFromFile(nstldtstrAlt);
            // DateTime date1 = DateTime.Parse(Properties.Settings.Default.date1);
            // DateTime date2 = DateTime.Parse(Properties.Settings.Default.date2);
            DateTime registryDate1 = ReadDateFromRegistry("date1");
            DateTime registryDate2 = ReadDateFromRegistry("date2");

            /*
            if (DateTime.Now >= strtpcntrDate && DateTime.Now <= strtpcntrAltDate &&
                DateTime.Now >= nstldtstrDate && DateTime.Now <= nstldtstrAltDate &&
                DateTime.Now >= date1 && DateTime.Now <= registryDate1 &&
                DateTime.Now >= date2 && DateTime.Now <= registryDate2)
            {
                MessageBox.Show("Trial active.");
                component = 1;
            }
            else
            {
                MessageBox.Show("License tampering detected.");
                Properties.Settings.Default.ks0 = true;
                Properties.Settings.Default.Save();
                component = 2;
            }
            */

            // Check if tampering files/keys exist
            if (File.Exists(trCheckerManip) ||
                Registry.CurrentUser.OpenSubKey(@"Software\Manip Solutions")?.GetValue("ksactive") != null ||
                Properties.Settings.Default.ks0)
            {
                component = 2;
            }

            uiShifter();

            trialActivation1.Location = new Point(1, -1);
            trialActivation1.BringToFront();
        }

        private void CheckAndCreateDirectory(string directoryPath)
        {
            try
            {
                if (!Directory.Exists(directoryPath))
                {
                    Directory.CreateDirectory(directoryPath);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show($"Failed to create directory: {ex.Message}");
            }
        }

        private void CheckAndCreateFile(string filePath, string content = "")
        {
            try
            {
                if (!File.Exists(filePath))
                {
                    if (string.IsNullOrEmpty(content))
                    {
                        File.WriteAllText(filePath, DateTime.Now.ToString());
                    }
                    else
                    {
                        File.WriteAllText(filePath, content);
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show($"Failed to create file: {ex.Message}");
            }
        }

        private DateTime ReadDateFromFile(string filePath)
        {
            DateTime date = DateTime.MinValue;

            try
            {
                if (File.Exists(filePath))
                {
                    string content = File.ReadAllText(filePath);
                    DateTime.TryParse(content, out date);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show($"Failed to read file: {ex.Message}");
            }

            return date;
        }

        private DateTime ReadDateFromRegistry(string valueName)
        {
            DateTime date = DateTime.MinValue;

            try
            {
                using (RegistryKey key = Registry.CurrentUser.OpenSubKey(@"Software\Manip Solutions"))
                {
                    if (key != null)
                    {
                        string value = key.GetValue(valueName)?.ToString();
                        DateTime.TryParse(value, out date);
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show($"Failed to read registry value: {ex.Message}");
            }

            return date;
        }

        private void CreateRegistryKey(string valueName)
        {
            try
            {
                using (RegistryKey key = Registry.CurrentUser.CreateSubKey(@"Software\Manip Solutions"))
                {
                    key.SetValue(valueName, true);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show($"Failed to create registry key: {ex.Message}");
            }
        }

        // ---------------------------------------------
        // Anti-tamper Secondary System
        // ---------------------------------------------

        static void TrW()
        {
            string path01 = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Temp Cached Modifiable Data v4779");
            string path02 = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), "Temporary 88791230 Dataset");

            DateTime localAppDataCreationDate = GetDirectoryCreationDate(path01);
            DateTime commonAppDataCreationDate = GetDirectoryCreationDate(path02);

            DateTime oldestCreationDate = (localAppDataCreationDate < commonAppDataCreationDate) ? localAppDataCreationDate : commonAppDataCreationDate;

            if (DateTime.Now - oldestCreationDate >= TimeSpan.FromDays(7))
            {
                CreateFileIfNotExists(Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "West Ltd", "ConsolidatedMediaCache", "cache_000.txt"));
                CreateFileIfNotExists(Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Apps", "app_id_lldl.txt"));
                CreateFileIfNotExists(Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "Roaming", "Demo Labs Cache", "0.txt"));
                CreateFileIfNotExists(Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), "Demux Client Settings", "user_sett_2022.txt"));
            }

            string[] filePaths = new string[]
            {
                Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "West Ltd", "ConsolidatedMediaCache", "cache_000.txt"),
                Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Apps", "app_id_lldl.txt"),
                Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "Demo Labs Cache", "0.txt"),
                Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), "Demux Client Settings", "user_sett_2022.txt"),
                Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Manip SSolutions", "f11623dfcb294645b8cf439686a5fa6f.txt")
            };

            foreach (string filePath in filePaths)
            {
                if (File.Exists(filePath))
                {
                    Properties.Settings.Default.ks = true; // Set your desired value here
                    Properties.Settings.Default.Save();
                    break;
                }
            }
        }

        static DateTime GetDirectoryCreationDate(string directoryPath)
        {
            if (!Directory.Exists(directoryPath))
                return DateTime.MinValue;

            try
            {
                return Directory.GetCreationTime(directoryPath);
            }
            catch
            {
                return DateTime.MinValue;
            }
        }

        static void CreateFileIfNotExists(string filePath)
        {
            string directoryPath = Path.GetDirectoryName(filePath);

            try
            {
                if (!Directory.Exists(directoryPath))
                    Directory.CreateDirectory(directoryPath);
            }
            catch // (Exception ex)
            {
                // Do nothing
            }

            try
            {
                if (!File.Exists(filePath))
                    File.Create(filePath).Dispose();
            }
            catch // (Exception ex)
            {
                // Do nothing
            }
        }

        // ---------------------------------------------
        // Real Trial Check System
        // ---------------------------------------------

        private void CheckTrialStatus()
        {
            // ---------------------------------------------
            // Activates Anti-Tamper Protection System
            // ---------------------------------------------

            try
            {
                string appDataFolderPath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "Temp Cached Modifiable Data v4779");
                string programDataFolderPath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), "Temporary 88791230 Dataset");

                CreateDirectoryIfNotExists(strtpcntr);
                CreateDirectoryIfNotExists(strtpcntrAlt);

                CreateDirectoryIfNotExists(nstldtstr);
                CreateDirectoryIfNotExists(nstldtstrAlt);

                string guid = GenerateUniqueGuid();
                string fileName = guid.Replace("-", "") + ".txt";

                string appDataFilePath = Path.Combine(appDataFolderPath, fileName);
                string programDataFilePath = Path.Combine(programDataFolderPath, fileName);

                File.WriteAllText(appDataFilePath, guid);
                File.WriteAllText(programDataFilePath, guid);

                CheckFileCountAndDeleteOldestFile(strtpcntr);
                CheckFileCountAndDeleteOldestFile(strtpcntrAlt);
            }
            catch // (Exception ex)
            {
                component = 2;
            }

        }

        // ---------------------------------------------
        // Real Trial Check System
        // ---------------------------------------------
        private void CheckTrialPeriod()
        {
            bool isExpired = IsTrialExpired();

            if (isExpired == false)
            {
                // Perform actions for when the trial is still active
                component = 1;
            }
            else if (isExpired == true)
            {
                // Perform actions for when the trial has expired
                component = 2;
            }

            if (Properties.Settings.Default.ks == true)
            {
                dateStringExpires = "null_td";

                // Perform actions for when the trial is still active
                component = 2;
            }
            else
            {
                dateStringExpires = trialDateExpiration.ToString();
            }

            dateStringExpires = trialDateExpiration.ToString();

            uiShifter();

            trialActivation1.Location = new Point(1, -1);
            trialActivation1.BringToFront();
        }

        // ---------------------------------------------
        // Startup counter: Delete Oldest File
        // ---------------------------------------------

        static void CheckFileCountAndDeleteOldestFile(string directoryPath)
        {
            string[] files = Directory.GetFiles(directoryPath, "*.txt");

            if (files.Length > 500)
            {
                Array.Sort(files, StringComparer.InvariantCulture);
                File.Delete(files[0]);
            }
        }

        // ---------------------------------------------
        // Startup counter: GUID Generator
        // ---------------------------------------------

        static string GenerateUniqueGuid()
        {
            string guid;
            do
            {
                guid = Guid.NewGuid().ToString();
            } while (FileExists(guid));

            return guid;
        }

        // ---------------------------------------------
        // Startup counter: Creates New Startup File
        // ---------------------------------------------

        static bool FileExists(string guid)
        {
            string path1 = Path.Combine(strtpcntr, guid.Replace("-", "") + ".txt");
            string path2 = Path.Combine(strtpcntrAlt, guid.Replace("-", "") + ".txt");

            return File.Exists(path1) || File.Exists(path2);
        }

        // ---------------------------------------------
        // Directory creator: Creates Directories
        // ---------------------------------------------

        static void CreateDirectoryIfNotExists(string directoryPath)
        {
            if (!Directory.Exists(directoryPath))
            {
                Directory.CreateDirectory(directoryPath);
            }
        }

        // ---------------------------------------------
        // Trial checker: Checks the Installation Date
        // ---------------------------------------------

        public bool IsTrialExpired()
        {
            DateTime installationDate = GetOldestInstallationDate(folderPaths);
            DateTime newestVetoFileCreationDate = GetNewestFileCreationDate(folderPathsVeto);
            DateTime trialEndDate = installationDate.AddDays(TrialPeriodDays);

            trialDateExpiration = trialEndDate;

            return newestVetoFileCreationDate > trialEndDate;
        }

        private DateTime GetOldestInstallationDate(string[] folderPaths)
        {
            DateTime installationDate = DateTime.MaxValue;

            foreach (string folderPath in folderPaths)
            {
                try
                {
                    if (Directory.Exists(folderPath))
                    {
                        string[] files = Directory.GetFiles(folderPath);

                        if (files.Length > 0)
                        {
                            DateTime fileCreationDate = File.GetCreationTime(files[0]);
                            if (fileCreationDate < installationDate)
                            {
                                installationDate = fileCreationDate;
                            }
                        }
                    }
                }
                catch // (Exception ex)
                {
                    // Handle the exception, log it, or perform any necessary actions
                    // Console.WriteLine($"An error occurred while getting installation date: {ex.Message}");
                }
            }

            return installationDate;
        }

        private DateTime GetNewestFileCreationDate(string[] folderPaths)
        {
            DateTime newestFileCreationDate = DateTime.MinValue;

            foreach (string folderPath in folderPaths)
            {
                try
                {
                    if (Directory.Exists(folderPath))
                    {
                        string[] files = Directory.GetFiles(folderPath);

                        if (files.Length > 0)
                        {
                            foreach (string file in files)
                            {
                                DateTime fileCreationDate = File.GetCreationTime(file);
                                if (fileCreationDate > newestFileCreationDate)
                                {
                                    newestFileCreationDate = fileCreationDate;
                                }
                            }
                        }
                    }
                }
                catch // (Exception ex)
                {
                    // Handle the exception, log it, or perform any necessary actions
                    // Console.WriteLine($"An error occurred while getting file creation date: {ex.Message}");
                }
            }

            return newestFileCreationDate;
        }

        private void uiShifter()
        {

            switch (component)
            {
                case 1: // Free Trial is Active

                    label1.Text = "Your 14-day free trial is now active!";
                    label3.Text = "During your free 14-day trial period, you can explore and use all the features of Low Specs Experience and decide if it's the right fit for you. Once the trial period ends, you can upgrade to the full version of Low Specs Experience Premium.";
                    label4.Text = "Trial Period Ends:";
                    continueToLSETrialPanel.Text = "Continue to Low Specs Experience";
                    label5.Text = TimeZoneInfo.ConvertTime(DateTimeOffset.FromUnixTimeSeconds(Properties.Settings.Default.user_sett_calc_cp), TimeZoneInfo.Local).DateTime.ToString();
                    label5.ForeColor = Color.LawnGreen;

                    break;

                // ----------------------------------------------------------------

                case 2: // Free Trial is Expired

                    label1.Text = "Your 14-day free trial has ended.";
                    label3.Text = "Thank you for trying Low Specs Experience! To continue enjoying all its features, please upgrade to the full version or activate your license key using the options below. Click the 'Buy Full Version' or 'Activate Full Version' buttons to proceed.";
                    label4.Visible = false;
                    label5.Visible = false;
                    continueToLSETrialPanel.Text = "Exit the Low Specs Experience";

                    // label4.Text = "Trial Period Status:";
                    label5.Text = "Free Trial Period Has Ended";
                    label5.ForeColor = Color.Red;

                    break;
            }
        }

        private void continueToLSETrialPanelMouseClick(object sender, EventArgs e)
        {
            if (continueToLSETrialPanel.Text == "Exit the Low Specs Experience")
            {
                Application.Exit();
            }
            else
            {
                trialActivation1.Hide();
            }
			
			// --- startup counter log - start

			try
			{
				// Ensure the directory exists
				if (!Directory.Exists(startupCounterPathSearch))
				{
					Directory.CreateDirectory(startupCounterPathSearch);
				}

				string filePath;
				do
				{
					// Get the current date and time in the specified format (no dashes or separators)
					string timestamp = DateTime.Now.ToString("yyyyMMddHHmmss");
					string logFileName = $"app_session_log_{timestamp}.log";
					filePath = Path.Combine(startupCounterPathSearch, logFileName);

				} while (File.Exists(filePath)); // Loop until we find a unique file name

				// Create the file and write "active" inside it
				// Write or append to the log file
				File.AppendAllText(filePath, $"Session started at: {DateTime.Now}");
				
				// Get all log files in the directory
				var logFiles = Directory.GetFiles(startupCounterPathSearch, "session_log_*.log")
										.OrderByDescending(File.GetCreationTime)
										.ToList();

				// Keep only the 25 most recent files
				if (logFiles.Count > 25)
				{
					var filesToDelete = logFiles.Skip(25); // Select files older than the 25 most recent
					foreach (var oldFile in filesToDelete)
					{
						File.Delete(oldFile);
					}
				}
			}
			catch
			{
				// Do nothing if an error occurs
			}

			// --- startup counter log - end
        }

        private void HomeButton_Click(object sender, EventArgs e)
        {
            // Sets the button paramteres
			mainUIOptimizationCatalog.Visible = false;
            mainUIStartup.BringToFront();
        }

        private void OptimizationCatalogButton_Click(object sender, EventArgs e)
        {
            // Sets the button paramteres
			mainUIOptimizationCatalog.Visible = true;
            mainUIOptimizationCatalog.BringToFront();
        }

        private void SupportAndHelpButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show(messageExternalLinkRedirectQuestion, captionExternalLinkRedirectQuestion, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                try
                {
                    System.Diagnostics.Process.Start("https://ragnos1997.com/support/");
                }
                catch
                {
                    MessageBox.Show(messageExternalLinkRedirectError, captionExternalLinkRedirectError, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void SettingsButton_Click(object sender, EventArgs e)
        {
            Form f = new appSettings();
            f.ShowDialog(this);
        }

        private void premiumGet_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show(messageExternalLinkRedirectQuestion, captionExternalLinkRedirectQuestion, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                try
                {
                    System.Diagnostics.Process.Start("https://ragnos1997.com/premium-membership/");
                }
                catch
                {
                    MessageBox.Show(messageExternalLinkRedirectError, captionExternalLinkRedirectError, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void premiumActivate_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Low Specs Experience will now redirect you to the full version activation section by opening a link in your default web browser. Do you wish to proceed?", "Activate Full Version", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                try
                {
                    System.Diagnostics.Process.Start("https://ragnos1997.com/premium-membership/activation/");
                }
                catch
                {
                    MessageBox.Show("An unknown internal error has occurred while trying to process your request. Please restart the Low Specs Experience and try again or contact support for assistance.", "Unknown Internal Error Occured", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            /*else
            {
                MessageBox.Show("Premium activation process has been terminated by the user.", "Premium Activation", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
            }*/
        }

        private void checkForUpdatesButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show(messageCheckForUpdatesQuestion, captionCheckForUpdatesQuestion, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                try
                {
                    string txtXml = "https://ragnos1997.com/x-ragnotechpowered-software-updates/LowSpecsExperience/CurrentVersion_v12.xml";

                    axcsCheck4Update.axMain oCheckClient = new axcsCheck4Update.axMain(txtXml);
                    int nMajor = oCheckClient.GetVersion(axcsCheck4Update.enVerion.EMajor);
                    int nMinor = oCheckClient.GetVersion(axcsCheck4Update.enVerion.EMinor);
                    int nBuild = oCheckClient.GetVersion(axcsCheck4Update.enVerion.EBuild);

                    string strPath = oCheckClient.GetNewVersionPath();

                    // Get my own version's numbers
                    Assembly assembly = Assembly.GetExecutingAssembly();
                    FileVersionInfo fileVersionInfo = FileVersionInfo.GetVersionInfo(assembly.Location);

                    int nAppMajor = fileVersionInfo.FileMajorPart;
                    int nAppMinor = fileVersionInfo.FileMinorPart;
                    int nAppBuild = fileVersionInfo.FileBuildPart;

                    if (nMajor > nAppMajor || nMinor > nAppMinor || nBuild > nAppBuild)
                    {
                        string newVerName = nMajor + "." + nMinor + "." + nBuild;
                        string currentVerName = Application.ProductVersion;

                        if (MessageBox.Show("A new version of Low Specs Experience is available.\n\nInstalled version: " + currentVerName + "\nLatest version: " + newVerName + "\n\nLow Specs Experience will now redirect you to an external link opening in your default web browser. You can review the update changes in the 'Updates' section of the website before deciding whether to proceed with the update.\n\nWould you like to proceed?", "Update Prompt Confirmation", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                        {
                            System.Diagnostics.Process.Start("https://ragnos1997.com/lse-ui-redirects/update-free");
                        }
                        else
                        {
                            MessageBox.Show("Check for updates operation was canceled by the user.",
                            "Check for Updates", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        }
                    }
                    else
                    {
                        MessageBox.Show("There are no new updates available at this time.",
                            "Low Specs Experience Up to Date", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                }
                catch (UnauthorizedAccessException)
                {
                    MessageBox.Show(messageCheckForUpdatesQuestionPermission, captionCheckForUpdatesQuestionPermission, MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                }
                catch
                {
                    MessageBox.Show(messageCheckForUpdatesQuestionError, captionCheckForUpdatesQuestionError, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void socialsFacebook_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show(messageExternalLinkRedirectQuestion, captionExternalLinkRedirectQuestion, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                try
                {
                    System.Diagnostics.Process.Start("https://ragnos1997.com/x-ragnotechpowered-link-redirects/SocialMediaFacebook.html");
                }
                catch
                {
                    MessageBox.Show(messageExternalLinkRedirectError, captionExternalLinkRedirectError, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void socialsTwitter_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show(messageExternalLinkRedirectQuestion, captionExternalLinkRedirectQuestion, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                try
                {
                    System.Diagnostics.Process.Start("https://ragnos1997.com/x-ragnotechpowered-link-redirects/SocialMediaTwitter.html");
                }
                catch
                {
                    MessageBox.Show(messageExternalLinkRedirectError, captionExternalLinkRedirectError, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void socialsYouTube_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show(messageExternalLinkRedirectQuestion, captionExternalLinkRedirectQuestion, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                try
                {
                    System.Diagnostics.Process.Start("https://ragnos1997.com/x-ragnotechpowered-link-redirects/SocialMediaYouTube.html");
                }
                catch
                {
                    MessageBox.Show(messageExternalLinkRedirectError, captionExternalLinkRedirectError, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void mainUI_Load(object sender, EventArgs e)
        {
			// --- startup counter log - start
			/*
			try
			{
				// Ensure the directory exists
				if (!Directory.Exists(startupCounterOnLoadPathSearch))
				{
					Directory.CreateDirectory(startupCounterOnLoadPathSearch);
				}

				string filePath;
				do
				{
					// Generate a new GUID and create the file path
					string guid = Guid.NewGuid().ToString();
					filePath = Path.Combine(startupCounterOnLoadPathSearch, $"{guid}.log");

				} while (File.Exists(filePath)); // Loop until we find a unique file name

				// Create the file and write "true" inside it
				File.WriteAllText(filePath, "true");
			}
			catch
			{
				// Do nothing if an error occurs
			}
			*/

            // --- startup counter log - end

            if (Properties.Settings.Default.neverShowAgainWelcomeScreen == false)
            {
                Form f = new welcomeScreen();
                f.ShowDialog(this);
            }
        }

        private void GettingStartedButton_Click(object sender, EventArgs e)
        {
            Form f = new GettingStarted();
            f.ShowDialog(this);
        }

        private async Task FetchUnixTimeAsync()
        {
			if (component != 2)
			{
				
				// ========================================
				// ONLINE TIME FETCH 1
				// ========================================
				
				await Task.Delay(100);

				// Get current online time main
				using (HttpClient client = new HttpClient())
				{
					// Get current online time using Regex to extract unixtime
					try
					{
						// Fetch the content from the API
						string content = await client.GetStringAsync("https://worldtimeapi.org/api/timezone/Etc/UTC");

						// Use a regex pattern to find "unixtime" and extract the number after it
						// \s* handles any amount of whitespace (spaces, tabs, etc.)
						Regex regex = new Regex("\"unixtime\"\\s*:\\s*(\\d+)", RegexOptions.Compiled);

						Match match = regex.Match(content);

						if (match.Success)
						{
							// The number after "unixtime" is in group 1
							string unixtime = match.Groups[1].Value;
							currentOnlineTime = Convert.ToInt64(unixtime);

							// DEBUG ONLY:
							// MessageBox.Show("Unixtime found: " + unixtime);
						}
						else
						{
							currentOnlineTime = 0;

							// DEBUG ONLY:
							// MessageBox.Show("No unixtime found in the content.");
						}
					}
					catch (Exception ex)
					{
						currentOnlineTime = 0;

						// DEBUG ONLY:
						// MessageBox.Show("Error: " + ex.Message);
					}

                    // DEBUG ONLY:
                    // MessageBox.Show(currentOnlineTime.ToString());
					
					// ========================================
					// ONLINE TIME FETCH 2
					// ========================================

					await Task.Delay(100);

					if (currentOnlineTime == 0)
					{
						// Get current online time alternative
						try
						{
							// Fetch the content from the API
							string content = await client.GetStringAsync("https://timeapi.io/api/Time/current/zone?timeZone=UTC");

							// Use Regex to extract the "dateTime" field value
							// The pattern looks for "dateTime": followed by a string in ISO 8601 format
							Regex regex = new Regex("\"dateTime\"\\s*:\\s*\"([^\"]+)\"", RegexOptions.Compiled);

							Match match = regex.Match(content);

							if (match.Success)
							{
								// Extract the dateTime string from group 1
								string dateTimeString = match.Groups[1].Value;

								// Parse the dateTime string to DateTimeOffset
								DateTimeOffset dateTimeOffsetAlt = DateTimeOffset.Parse(dateTimeString);

								// Convert to Unix epoch time (in seconds)
								currentOnlineTime = dateTimeOffsetAlt.ToUnixTimeSeconds();
								
								// DEBUG ONLY:
								// MessageBox.Show(currentOnlineTime.ToString());
							}
							else
							{
								currentOnlineTime = 0;

								// DEBUG ONLY:
								// MessageBox.Show("No unixtime found in the content.");
							}
						}
						catch (Exception ex)
						{
							currentOnlineTime = 0;

							// DEBUG ONLY:
							// MessageBox.Show("Error: " + ex.Message);
						}
					}
					
					await Task.Delay(100);
					
					// ========================================
					// ONLINE TIME FETCH 3
					// ========================================
					
					if (currentOnlineTime == 0)
					{
						// Get current online time alternative
						try
						{
							// Fetch the content from the URL
							string content = await client.GetStringAsync("https://ragnos1997.com/t/");

							// Step 2: Use a regex pattern to find "unixtime" and extract the number after it
							Regex regex = new Regex("unixtime:\\s*(\\d+)");
							Match match = regex.Match(content);

							if (match.Success)
							{
								// The number after "unixtime" is in group 1
								string unixtime = match.Groups[1].Value;
								currentOnlineTime = Convert.ToInt64(unixtime);

								// DEBUG ONLY:
								// MessageBox.Show("Unixtime found: " + unixtime);
							}
							else
							{
								currentOnlineTime = 0;

								// DEBUG ONLY:
								// MessageBox.Show("No unixtime found in the content.");
							}
						}
						catch (Exception ex)
						{
							currentOnlineTime = 0;

							// DEBUG ONLY:
							// MessageBox.Show("Error: " + ex.Message);
						}
					}
				}

                // DEBUG ONLY:
                // MessageBox.Show(currentOnlineTime.ToString());

                // ========================================
                // LOCAL TIME FETCH 1
                // ========================================

                await Task.Delay(100);

                if (currentOnlineTime == 0)
                {
                    // DEBUG ONLY
                    // MessageBox.Show("Still zero");

                    if (Directory.Exists(startupCounterPathSearch))
                    {
                        try
                        {
                            startupCounterPathSearchFile = Directory
                                .GetFiles(startupCounterPathSearch)
                                .Select(path => new FileInfo(path))
                                .OrderByDescending(file => file.LastWriteTime)
                                .FirstOrDefault()?.FullName ?? string.Empty;
                        }
                        catch (Exception ex)
                        {
                            startupCounterPathSearchFile = null;
                        }
                    }
                    else
                    {
                        startupCounterPathSearchFile = null;
                    }

                    // DEBUG ONLY
                    // MessageBox.Show(startupCounterPathSearchFile);

					try
					{
						// Create an array of the file paths
						string[] filePaths = {
							startupCounterPathSearchFile
							// startupCounterTEMPPathSearchFile
						};

						// Filter to get only the paths that are not null and exist
						var existingFiles = filePaths
							.Where(path => !string.IsNullOrEmpty(path) && File.Exists(path))
							.Select(path => new FileInfo(path))
							.ToList();

						// Check if we have any existing files
						if (existingFiles.Count > 0)
						{
							// Find the newest file by creation date
							var newestFile = existingFiles
								.OrderByDescending(file => file.CreationTime)
								.First();

							// Retrieve the creation time of the newest file in UTC
							DateTime creationTimeUtc = newestFile.CreationTimeUtc;
							long unixTimestamp = ((DateTimeOffset)creationTimeUtc).ToUnixTimeSeconds();

							// Set currentOnlineTime to the Unix timestamp of the UTC creation time
							currentOnlineTime = unixTimestamp;
						}
						else
						{
							// If no files are found, set currentOnlineTime to 0
							currentOnlineTime = 0;
						}
					}
					catch (Exception ex)
					{
						currentOnlineTime = 0;
					}
                }
					
				await Task.Delay(100);
					
				// ========================================
				// LOCAL TIME FETCH 2
				// ========================================

				if (currentOnlineTime == 0)
				{
					try
					{
						// Get the path to the Windows temporary directory
						string tempDirectoryPath = Path.GetTempPath();

						// Get all files in the temporary directory
						var tempFiles = Directory.GetFiles(tempDirectoryPath);

						// Find the newest file based on the last write time
						var newestFile = tempFiles
							.Select(f => new FileInfo(f))
							.OrderByDescending(f => f.LastWriteTime)
							.FirstOrDefault();

						// Check if a file was found
						if (newestFile != null)
						{
							// Convert LastWriteTime to UNIX timestamp
							DateTime lastWriteTimeUtc = newestFile.LastWriteTime.ToUniversalTime();
							currentOnlineTime = ((DateTimeOffset)lastWriteTimeUtc).ToUnixTimeSeconds();
						}
						else
						{
							currentOnlineTime = 0;
						}
					}
					catch (Exception ex)
					{
						currentOnlineTime = 0;
					}
				}
					
				await Task.Delay(100);
					
				// ========================================
				// LOCAL TIME FETCH 3
				// ========================================

				if (currentOnlineTime == 0)
				{
					try
					{
						DateTime nowInUtc = DateTime.UtcNow;
						DateTimeOffset utcOffsetTime = new DateTimeOffset(nowInUtc);
						long epochSeconds = utcOffsetTime.ToUnixTimeSeconds();
						currentOnlineTime = epochSeconds;
					}
					catch (Exception ex)
					{
						currentOnlineTime = 0;
					}
				}

                // DEBUG ONLY
                // MessageBox.Show(currentOnlineTime.ToString());

                // Check current date and time
                DateTime systemDateAndTime = DateTime.UtcNow;
                DateTimeOffset dateTimeOffset = new DateTimeOffset(systemDateAndTime);
                long unixTimestampCurrentSystemDateAndTime = dateTimeOffset.ToUnixTimeSeconds();

                // DEBUG ONLY
                // MessageBox.Show(unixTimestampCurrentSystemDateAndTime.ToString());

                // Check if the difference is within about a day
                bool isOutsideRange = false;
                isOutsideRange = Math.Abs(currentOnlineTime) > 100000;

                // DEBUG ONLY
                // MessageBox.Show(isOutsideRange.ToString());

                if (isOutsideRange == false)
				{
					component = 2;
						
					uiShifter();

					trialActivation1.Location = new Point(1, -1);
					trialActivation1.BringToFront();
					
					trialActivation1.Show();
					trialActivation1.Visible = true;

                    MessageBox.Show("An error occurred during trial period validation. Therefore, your access to Low Specs Experience has been restrcited.\n\nPlease ensure that you have an active Internet connection and try again.", "Trial Period Validation Failed", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

                    // Application.Exit();
                }
				else
				{
					// DEBUG ONLY:
					// MessageBox.Show(currentOnlineTime.ToString(), "Current Online Time Is:", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
						
					// Application.Exit();
				}
			}
        }

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool SetForegroundWindow(IntPtr hWnd);

        protected override void OnShown(EventArgs e)
        {
            base.OnShown(e);
            // Bring the window to the front
            SetForegroundWindow(this.Handle);
        }
		/*
		static bool IsAutomaticTimeEnabled()
		{
			try
			{
				// Query for the W32Time service status using WMI
				ManagementObjectSearcher searcher = new ManagementObjectSearcher("SELECT * FROM Win32_Service WHERE Name = 'w32time'");

				foreach (ManagementObject queryObj in searcher.Get())
				{
					// Check the StartMode to see if it is set to 'Auto'
					string startMode = queryObj["StartMode"].ToString();
					return startMode == "Auto";
				}

				return false;
			}
			catch (Exception ex)
			{
				Console.WriteLine("Error querying WMI: " + ex.Message);
				return false;
			}
		}
		*/
    }
}